"""
    Asset Cash Flow Projections API

    Allow clients to upload scenario files through APIs.  # noqa: E501

    The version of the OpenAPI document: 0.1.0
    Contact: api@factset.com
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from fds.sdk.AssetCashFlowProjections.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from fds.sdk.AssetCashFlowProjections.exceptions import ApiAttributeError



class UploadStatusResponseParameters(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
        ('type',): {
            'TILLINGHAST_ACTUARIAL_SOFTWARE_(TAS)': "Tillinghast Actuarial Software (TAS)",
            'MILLIMAN&#39;S_MG-ALFA_(ALFA)': "Milliman's MG-ALFA (ALFA)",
            'SUNGARD_IWORKS_PROPHET': "Sungard iWorks Prophet",
            'FACTSET': "FactSet",


        },
        ('acfp_status',): {
            'PENDING': "pending",
            'VALIDATING': "validating",
            'ERROR': "error",
            'REPLICATING': "replicating",
            'GOOD': "good",
            'PREPARING': "preparing",
            'UNINITIATED': "uninitiated",


        },
        ('status',): {
            'QUEUED': "queued",
            'EXECUTING': "executing",
            'CREATED': "created",


        },
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        return {
            'upload_id': (str,),  # noqa: E501
            'file_name': (str,),  # noqa: E501
            'as_of_date': (date,),  # noqa: E501
            'type': (str,),  # noqa: E501
            'acfp_status': (str,),  # noqa: E501
            'status': (str,),  # noqa: E501
            'upload_date_time': (datetime,),  # noqa: E501
            'number_of_scenarios': (float,),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'upload_id': 'uploadId',  # noqa: E501
        'file_name': 'fileName',  # noqa: E501
        'as_of_date': 'asOfDate',  # noqa: E501
        'type': 'type',  # noqa: E501
        'acfp_status': 'acfpStatus',  # noqa: E501
        'status': 'status',  # noqa: E501
        'upload_date_time': 'uploadDateTime',  # noqa: E501
        'number_of_scenarios': 'numberOfScenarios',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, *args, **kwargs):  # noqa: E501
        """UploadStatusResponseParameters - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            upload_id (str): Unique Identifier for the file. [optional]  # noqa: E501
            file_name (str): Actuarial Scenario file name. [optional]  # noqa: E501
            as_of_date (date): Scenario As of Date. [optional]  # noqa: E501
            type (str): Actuarial Scenario File Type. [optional]  # noqa: E501
            acfp_status (str): The ACFP status of the uploaded file, can be one of the following: - `pending`: File validation is pending. - `validating`:File is being validated. - `error`: File failed validation.  - `replicating`: File is being copied. - `good`: File is successfully validated. - `preparing`: File is being parsed.  - `uninitiated`: File upload is not initiated.. [optional]  # noqa: E501
            status (str): The status of the uploaded file, can be one of the following:. [optional]  # noqa: E501
            upload_date_time (datetime): The time stamp when the file is uploaded. [optional]  # noqa: E501
            number_of_scenarios (float): Number of scenarios that are within a scenario file. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, *args, **kwargs):  # noqa: E501
        """UploadStatusResponseParameters - a model defined in OpenAPI

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
            upload_id (str): Unique Identifier for the file. [optional]  # noqa: E501
            file_name (str): Actuarial Scenario file name. [optional]  # noqa: E501
            as_of_date (date): Scenario As of Date. [optional]  # noqa: E501
            type (str): Actuarial Scenario File Type. [optional]  # noqa: E501
            acfp_status (str): The ACFP status of the uploaded file, can be one of the following: - `pending`: File validation is pending. - `validating`:File is being validated. - `error`: File failed validation.  - `replicating`: File is being copied. - `good`: File is successfully validated. - `preparing`: File is being parsed.  - `uninitiated`: File upload is not initiated.. [optional]  # noqa: E501
            status (str): The status of the uploaded file, can be one of the following:. [optional]  # noqa: E501
            upload_date_time (datetime): The time stamp when the file is uploaded. [optional]  # noqa: E501
            number_of_scenarios (float): Number of scenarios that are within a scenario file. [optional]  # noqa: E501
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
